<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<HTML>
    <HEAD>
        <TITLE>Simulated DMT Documentation</TITLE>
    </HEAD>

    <BODY>
        <H1 align="center">How to run simulated DMT Test</H1>

        <P>The simulated dmt test tests insertion of DMT generated triggers and relevant data such as process, process params,
		segments. The test exercises the following:
		<UL>
		<LI>Ability of ldas to ingest data from external xml formatted by dmt process by retrieving xml from url,
		converting it into ilwd format and inserting the data into the database.</LI><p>
		
		<LI>Account for all the data sent to ldas from dmt: at times there maybe errors obtaining the file from url, or there
		maybe due foreign key errors if the data is not inserted in sequence.  To ensure data integrity some fine tuning maybe
		necessary for the test e.g extending http time out in the ligolwAPI when the system is very busy. 
		</UL>
		
		<P>The LDAS APIs affected by this test are:
		<UL>
		<LI><font color='blue'>managerAPI</font>: directs processing of the insertion user commands to the ligolwAPI and metadataAPI
			and returns the user command status to the user.</LI><p>
		<LI><font color='blue'>ligolwAPI</font>: 
			<UL>
			<LI>Retrieves the data to be ingested from the specified url to ilwd object and sends the ilwd
			to the metadataAPI for insertion.
			</UL><p>
		<LI><font color='blue'>metadataAPI</font>: 
			<UL>
			<LI>insert the metadata ilwd data from ligolwAPI into the specified database.</LI>
			</UL>
		</UL>
		
		
        <H2>Setup</H2>
        <P>Choose a directory to install the tests scripts.  
		<UL>
		<LI>The script files are:

        <P><CODE><font color='blue'>dmt.test</font> - main driver script<BR>
        <font color='blue'>metadata_test.tcl</font> - individual user cmd test driver<BR>
		<font color='blue'>putMetaDataDMT.tcl</font> - DMT files test driver<BR>
		<font color='blue'>analyseDMT.tcl</font> - extract DMT logs and accounts for all dmt user commands<BR>
		<font color='blue'>xmlist</font> - list of gds_trigger xmls stored at LHO, average dims is 10<BR>
		<font color='blue'>TrigAlt.xmls </font> - Another set of gds_trigger xmls from LLO of dims 100<BR>
		</CODE></LI>
				
		<LI>Environment variables:<p>
		 Environment variable SSH_AUTH_SOCK is required to allow execution of scripts on dataserver to retrieve logs.
		 To set this, on the ldas gateway, find out the name of the ldas agent by running the ldas utility ldasagent.
		 Then setenv SSH_AUTH_SOCK to the output of ldasagent if an agent exists.
		 Then login to metaserver; verify that the environment variable is set before running the test.
		 </LI>
        
        <P><B>Note:</B> At all the sites, the required script files are installed at <CODE>/ldas_usr/ldas/test/database</CODE>.  
		</UL>
        <H2>Running the test</H2>
		The test must be run from the host where db2 resides, i.e. <font color='brown'>metaserver</font> and run in the scripts directory e.g. /ldas_usr/ldas/test/database.
		
		<p>cd /ldas_usr/ldas/test/database<p>
		
        <B>Usage:</B> <CODE>dmt.test [options] >& dmt.out & </CODE>

        <P><TABLE border=1 cellspacing=0 cellpadding=10>
            <TR>
                <TH><B>Option</B>
                <TH><B>Description</B>
            <TR>
                <TD valign=top><CODE>&lt;dsname&gt;</CODE>
                <TD>database name for the test
        </TABLE>

		<p>
		<H2>Test Verification:</H2>
		The test should be monitored initially to make sure data is flowing in a steady pace and that the insertions
		are successful impling that data is inserted in the correct sequence.<p>
		<OL>
		<LI><font color='magenta'>Monitoring dmt</font><p>
			All output from script dmt.test is directed to stdout which can be redirected to a file e.g. dmt.out.<p>
			The database is cleared for dmt data which involves removing the dmt processes, associated process_params,
			gds_triggers and segments.<p>
			A putMetaData user command is generated for each of the dmt files and sent to the managerAPI. The insertions
			can be monitored from the ldas logs and  the database page for the specified database. </LI>
		<p>
		<LI><font color='magenta'>Analysis</font><p>
			When all the xmls are sent to LDAS, the logs are extraced by analyseDMT.tcl on dataserver; it checks for
			the following from the logs:
			<ul>
			<li>Number of putMetaData user commands for triggers entering manager = number of xmls in xml file list</li>
			<li>Number of objects sent from ligolwAPI = number received at metadataAPI</li>
			<li>Number of objects inserted by metadataAPI = number received at metadataAPI</li>
			</ul>
			<p>If there is any errors, analyseDMT.tcl also reports them to the output log analyseDMT.log.
			
			deldmt.tcl script is called to clean up after dmt, but before deleting any dmt data, it reports the
			number of rows of processes, process_params and gds_triggers; verify that <p>
			<li>Number of rows of process and process_parms if any inserted into the database = 
				Number of gds_triggers reported by metadataAPI</li><p>
			<li>Number of rows of triggers inserted into the database = Number of gds_triggers reported by metadataAPI</li>
			
			If all the process and trigger data are inserted, the test <font color='green'>passes</font>. 
			If not, the test <font color='red'>fails</font> and the logs should account for all data received at LDAS.
		</OL>	
    </BODY>
</HTML>

